"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "PackageJsonManager", {
    enumerable: true,
    get: function() {
        return PackageJsonManager;
    }
});
const _JsonManager = require("./JsonManager");
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
class PackageJsonManager extends _JsonManager.JsonManager {
    static load(filepath, fs) {
        if (this._instance) {
            throw new Error(`Cannot create a second instance of PackageJsonManager`);
        }
        let data;
        try {
            data = fs.readJSON(filepath);
        } catch (error) {
            data = undefined;
        }
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        PackageJsonManager._instance = new PackageJsonManager(filepath, fs, data);
    }
    static reset() {
        PackageJsonManager._instance = undefined;
    }
    static get instance() {
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        return this._instance;
    }
    addDependency(dependency, version) {
        // check that version is valid semver?
        // resolve any conflicts
        if (!PackageJsonManager.instance.data.dependencies) {
            PackageJsonManager.instance.data.dependencies = {};
        }
        PackageJsonManager.instance.data.dependencies[dependency] = version;
    }
    addDevDependency(dependency, version) {
        if (!PackageJsonManager.instance.data.devDependencies) {
            PackageJsonManager.instance.data.devDependencies = {};
        }
        PackageJsonManager.instance.data.devDependencies[dependency] = version;
    }
    addResolution(dependency, resolution) {
        if (!PackageJsonManager.instance.data.resolutions) {
            PackageJsonManager.instance.data.resolutions = {};
        }
        PackageJsonManager.instance.data.resolutions[dependency] = resolution;
    }
}
_define_property(PackageJsonManager, "_instance", void 0);

//#sourceMappingUrl=./PackageJsonManager.js.map