"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "ServeJsonManager", {
    enumerable: true,
    get: function() {
        return ServeJsonManager;
    }
});
const _lodash = /*#__PURE__*/ _interop_require_wildcard(require("lodash"));
const _JsonManager = require("./JsonManager");
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
class ServeJsonManager extends _JsonManager.JsonManager {
    static load(filepath, fs) {
        if (this._instance) {
            throw new Error(`Cannot create a second instance of ServeJsonManager`);
        }
        let data;
        try {
            data = fs.readJSON(filepath);
        } catch (error) {
            // Bootstrap the serve.json file with the basic information
            data = undefined;
        }
        if (!data) {
            data = {
                $schema: 'https://developer.microsoft.com/json-schemas/spfx-build/spfx-serve.schema.json',
                port: 4321,
                https: true
            };
        }
        ServeJsonManager._instance = new ServeJsonManager(filepath, fs, data);
    }
    static reset() {
        ServeJsonManager._instance = undefined;
    }
    static get instance() {
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        return this._instance;
    }
    addConfiguration(name, configuration) {
        // The first configuration is the default one
        if (!this.data.serveConfigurations) {
            this.data.serveConfigurations = {
                default: configuration
            };
        }
        this.data.serveConfigurations[name] = configuration;
    }
    setUpForWebParts() {
        _lodash.merge(this.data, {
            initialPage: 'https://{tenantDomain}/_layouts/workbench.aspx',
            https: true
        });
    }
}
_define_property(ServeJsonManager, "_instance", void 0);

//#sourceMappingUrl=./ServeJsonManager.js.map