"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "TeamsManifestJsonManager", {
    enumerable: true,
    get: function() {
        return TeamsManifestJsonManager;
    }
});
const _JsonManager = require("./JsonManager");
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
class TeamsManifestJsonManager extends _JsonManager.JsonManager {
    static load(filepath, fs) {
        if (this._instance) {
            throw new Error(`Cannot create a second instance of TeamsManifestJsonManager`);
        }
        let data;
        try {
            data = fs.readJSON(filepath);
        } catch (error) {
            data = undefined;
        }
        if (!data) {
            data = {
                $schema: 'https://developer.microsoft.com/en-us/json-schemas/teams/v1.2/MicrosoftTeams.schema.json'
            };
        }
        TeamsManifestJsonManager._instance = new TeamsManifestJsonManager(filepath, fs, data);
    }
    static reset() {
        TeamsManifestJsonManager._instance = undefined;
    }
    static get instance() {
        return this._instance;
    }
    setUpManifest(teamsManifestData) {
        const data = this.data;
        data.packageName = teamsManifestData.componentName;
        data.name.short = teamsManifestData.componentName;
        data.id = teamsManifestData.componentId;
        data.description.short = teamsManifestData.componentDescription;
        data.description.full = teamsManifestData.componentDescription;
        /*
     * 'dest' query parameter must be encoded to avoid being processed
     * as separate query parameters by the server.
     * %3F = ?
     * %26 = &
     */ data.configurableTabs[0].configurationUrl = 'https://{teamSiteDomain}{teamSitePath}/_layouts/15/TeamsLogon.aspx' + '?SPFX=true' + '&dest={teamSitePath}/_layouts/15/teamshostedapp.aspx' + '%3FopenPropertyPane=true' + '%26teams' + `%26componentId=${teamsManifestData.componentId}` + '%26forceLocale={locale}';
    }
}
_define_property(TeamsManifestJsonManager, "_instance", void 0);

//#sourceMappingUrl=./TeamsManifestJsonManager.js.map