"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "default", {
    enumerable: true,
    get: function() {
        return spsay;
    }
});
const _colors = /*#__PURE__*/ _interop_require_default(require("colors"));
const _lodash = /*#__PURE__*/ _interop_require_default(require("lodash"));
function _interop_require_default(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
const logo = [
    '      _=+#####!       ',
    '   ###########|       ',
    '   ###/    (##|(@)    ',
    '   ###  ######|   \\   ',
    '   ###/   /###|   (@) ',
    '   #######  ##|   /   ',
    '   ###     /##|(@)    ',
    '   ###########|       ',
    '      **=+####!       '
];
function times(n, character) {
    return _lodash.default.times(n, ()=>character).join('');
}
function space(n) {
    return times(n, ' ');
}
function getWords(solutionName, useHeft) {
    const words = [
        `Congratulations!`,
        `Solution ${solutionName} is created.`,
        `Run ${useHeft ? 'npm run start' : 'gulp serve'} to play with it!`
    ];
    const colorWords = [
        `Congratulations!`,
        `Solution ${_colors.default.cyan(solutionName)} is created.`,
        `Run ${_colors.default.yellow(useHeft ? 'npm run start' : 'gulp serve')} to play with it!`
    ];
    const maxLength = Math.max.apply(undefined, words.map((word)=>word.length));
    const formatted = colorWords.map((word, index)=>{
        const padding = maxLength - words[index].length;
        const rightPadding = Math.floor(padding / 2);
        const leftPadding = padding - rightPadding;
        return space(leftPadding) + word + space(rightPadding);
    });
    const wrapped = [
        ''
    ].concat([
        '.' + times(maxLength + 4, '-') + '.'
    ]).concat(formatted.map((word)=>'|  ' + word + '  |')).concat([
        "'" + times(maxLength + 4, '-') + "'"
    ]);
    return wrapped;
}
function spsay(solutionName, useHeft) {
    const colorLogo = logo.map((line)=>_colors.default.cyan(line));
    const words = getWords(solutionName, useHeft);
    const lines = _lodash.default.zip(colorLogo, words).map((parts)=>parts.join(''));
    return '\n' + lines.join('\n') + '\n';
}

//#sourceMappingUrl=./spsay.js.map