"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    BaseACEGenerator: function() {
        return BaseACEGenerator;
    },
    defineOptions: function() {
        return defineOptions;
    }
});
const _utilities = /*#__PURE__*/ _interop_require_wildcard(require("../../common/utilities"));
const _BaseComponentGenerator = /*#__PURE__*/ _interop_require_wildcard(require("../component/BaseComponentGenerator"));
const _YeomanConfiguration = require("../../common/YeomanConfiguration");
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function defineOptions(generator, type = 'AdaptiveCardExtension') {
    _BaseComponentGenerator.defineOptions(generator, type);
}
class BaseACEGenerator extends _BaseComponentGenerator.BaseComponentGenerator {
    configuring() {
        super.configuring();
        this.ensureDependencyGroup('adaptiveCardExtension');
        const solutionName = _YeomanConfiguration.YeomanConfiguration.libraryName;
        this.packageSolutionJson.addFeature(_utilities.generateGuid(), `${solutionName} Feature`, `The feature that activates elements of the ${solutionName} solution.`, false);
        this.serveJson.setUpForWebParts();
    }
    writing(shouldCopy = true) {
        super.writing(true);
    }
    install() {
        super.install();
    }
    constructor(...args){
        super(...args);
        _define_property(this, "friendlyName", 'Adaptive Card Extension');
        _define_property(this, "codeName", 'AdaptiveCardExtension');
        _define_property(this, "allowedTemplates", []);
        _define_property(this, "folderName", 'adaptiveCardExtensions');
    }
}

//#sourceMappingUrl=./BaseAdaptiveCardExtensionGenerator.js.map