"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    AdaptiveCardExtensionSelectorGenerator: function() {
        return AdaptiveCardExtensionSelectorGenerator;
    },
    composeWith: function() {
        return composeWith;
    },
    defineOptions: function() {
        return defineOptions;
    }
});
const _path = /*#__PURE__*/ _interop_require_wildcard(require("path"));
const _colors = /*#__PURE__*/ _interop_require_default(require("colors"));
const _BaseGenerator = require("../../common/BaseGenerator");
const _utilities = /*#__PURE__*/ _interop_require_wildcard(require("../../common/utilities"));
const _genericAdaptiveCardExtension = /*#__PURE__*/ _interop_require_wildcard(require("../genericAdaptiveCardExtension"));
const _searchAdaptiveCardExtension = /*#__PURE__*/ _interop_require_wildcard(require("../searchAdaptiveCardExtension"));
const _dataVisualizationAdaptiveCardExtension = /*#__PURE__*/ _interop_require_wildcard(require("../dataVisualizationAdaptiveCardExtension"));
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interop_require_default(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function composeWith(base, options) {
    _utilities.compose(_path.basename(__dirname), base, options);
}
function defineOptions(generator) {
    _genericAdaptiveCardExtension.defineOptions(generator);
    _searchAdaptiveCardExtension.defineOptions(generator);
    _dataVisualizationAdaptiveCardExtension.defineOptions(generator);
}
class AdaptiveCardExtensionSelectorGenerator extends _BaseGenerator.BaseGenerator {
    initializing() {
    /* no-op */ }
    async prompting() {
        this.ensureCorrectFolder();
        if (!this._shouldExecute()) {
            return;
        }
        const choices = [
            {
                name: 'Generic Card Template',
                value: 'Generic'
            },
            {
                name: 'Search Card Template',
                value: 'Search'
            },
            {
                name: 'Data Visualization Card Template',
                value: 'DataVisualization'
            }
        ];
        const answers = await this.prompt([
            {
                type: 'list',
                name: 'aceTemplateType',
                default: 'PrimaryText',
                when: ()=>!this.config.get('aceTemplateType'),
                message: 'Which template do you want to use?',
                choices
            }
        ]);
        const templateType = answers.aceTemplateType || this.config.get('aceTemplateType');
        if (!(templateType === 'Generic' || templateType === 'Search' || templateType === 'DataVisualization')) {
            this.log(_colors.default.red(`Invalid template type: '${templateType}'`));
        } else {
            this.config.set('aceTemplateType', templateType);
        }
    }
    configuring() {
    /* no-op */ }
    writing() {
    /* no-op */ }
    install() {
    /* no-op */ }
    end() {
    /* no-op */ }
    _shouldExecute() {
        return this.config.get('environment') === 'spo' && this.config.get('componentType') === 'adaptiveCardExtension' && this.config.get('isDomainIsolated') === false;
    }
    constructor(args, options){
        super(args, options);
        _define_property(this, "friendlyName", 'Adaptive Card Selection');
    }
}
// Yeoman expects exports of this type, which overrides the TS exports above
// Ensure that anything marked as export above is also listed here
module.exports = AdaptiveCardExtensionSelectorGenerator;
module.exports.defineOptions = defineOptions;
module.exports.composeWith = composeWith;

//#sourceMappingUrl=./index.js.map