"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "composeWith", {
    enumerable: true,
    get: function() {
        return composeWith;
    }
});
const _colors = /*#__PURE__*/ _interop_require_default(require("colors"));
const _path = /*#__PURE__*/ _interop_require_wildcard(require("path"));
const _yosay = /*#__PURE__*/ _interop_require_default(require("yosay"));
const _nodecorelibrary = require("@rushstack/node-core-library");
const _spsay = /*#__PURE__*/ _interop_require_default(require("../../common/spsay"));
const _BaseGenerator = require("../../common/BaseGenerator");
const _utilities = /*#__PURE__*/ _interop_require_wildcard(require("../../common/utilities"));
const _YeomanConfiguration = require("../../common/YeomanConfiguration");
const _solution = /*#__PURE__*/ _interop_require_wildcard(require("../solution"));
const _component = /*#__PURE__*/ _interop_require_wildcard(require("../component"));
const _webpart = /*#__PURE__*/ _interop_require_wildcard(require("../webpart"));
const _extension = /*#__PURE__*/ _interop_require_wildcard(require("../extension"));
const _library = /*#__PURE__*/ _interop_require_wildcard(require("../library"));
const _adaptiveCardExtension = /*#__PURE__*/ _interop_require_wildcard(require("../adaptiveCardExtension"));
const _fieldCustomizer = /*#__PURE__*/ _interop_require_wildcard(require("../fieldCustomizer"));
const _commandSet = /*#__PURE__*/ _interop_require_wildcard(require("../commandSet"));
const _searchQueryModifier = /*#__PURE__*/ _interop_require_wildcard(require("../searchQueryModifier"));
const _applicationCustomizer = /*#__PURE__*/ _interop_require_wildcard(require("../applicationCustomizer"));
const _formCustomizer = /*#__PURE__*/ _interop_require_wildcard(require("../formCustomizer"));
const _genericAdaptiveCardExtension = /*#__PURE__*/ _interop_require_wildcard(require("../genericAdaptiveCardExtension"));
const _searchAdaptiveCardExtension = /*#__PURE__*/ _interop_require_wildcard(require("../searchAdaptiveCardExtension"));
const _dataVisualizationAdaptiveCardExtension = /*#__PURE__*/ _interop_require_wildcard(require("../dataVisualizationAdaptiveCardExtension"));
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interop_require_default(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
const VERSION = require('../../../package.json').version;
function composeWith(base, options) {
    _utilities.compose(_path.basename(__dirname), base, options);
}
/**
 * This class is the entry point when running `yo @microsoft/sharepoint`
 */ class AppGenerator extends _BaseGenerator.BaseGenerator {
    initializing() {
        this.log((0, _yosay.default)('Welcome to the Microsoft 365 ' + _colors.default.blue(`SPFx Yeoman Generator@${VERSION}`)));
        this._provideRetirementNote();
        this._explainArguments();
        this.context.creatingSolution = !_YeomanConfiguration.YeomanConfiguration.libraryName;
        const shouldUseSubDir = this.options.solutionName !== undefined;
        if (shouldUseSubDir) {
            // changing destinationRoot to the subfolder
            this.destinationRoot(this.destinationPath(this.options.solutionName));
            // we need to manually update cwd to point to the subfolder as this.destinationRoot() will not do it
            this.env.cwd = this.destinationRoot();
            this.config.set('whichFolder', 'subdir');
        }
        if (this.options.solutionName !== undefined) {
            this.config.set('solutionName', this.options.solutionName);
        }
        if (this.options.solutionShortDescription !== undefined) {
            this.config.set('solutionShortDescription', this.options.solutionShortDescription);
        }
        if (this.options.environment !== undefined) {
            this.config.set('environment', this.options.environment);
        }
        if (this.options.packageManager !== undefined) {
            this.config.set('packageManager', this.options.packageManager);
        }
        if (this.options.skipFeatureDeployment !== undefined) {
            this.config.set('skipFeatureDeployment', this.options.skipFeatureDeployment);
        }
        if (this.options.isDomainIsolated !== undefined) {
            this.config.set('isDomainIsolated', this.options.isDomainIsolated);
        }
        if (this.options.useHeft !== undefined) {
            this.config.set('useHeft', this.options.useHeft);
        }
        if (this.options.componentType !== undefined) {
            this.config.set('componentType', this.options.componentType);
        } else {
            this.config.set('componentType', undefined);
        }
        if (this.options.extensionType !== undefined) {
            this.config.set('extensionType', this.options.extensionType);
        } else {
            this.config.set('extensionType', undefined);
        }
        if (this.options.aceTemplateType !== undefined) {
            this.config.set('aceTemplateType', this.options.aceTemplateType);
        } else {
            this.config.set('aceTemplateType', undefined);
        }
        if (this.options.framework !== undefined) {
            this.config.set('template', this.options.framework);
        }
        if (this.options.template !== undefined) {
            this.config.set('template', this.options.template);
        }
        if (this.options.componentName !== undefined) {
            this.config.set('componentName', this.options.componentName);
        } else {
            this.config.set('componentName', undefined);
        }
        if (this.options.componentDescription !== undefined) {
            this.config.set('componentDescription', this.options.componentDescription);
        } else {
            this.config.set('componentDescription', undefined);
        }
        this.config.set('plusBeta', VERSION.indexOf('beta') >= 0);
        this.config.set('isCreatingSolution', this.context.creatingSolution);
        this.config.set('nodeVersion', process.versions.node);
        this._setSDKsVersions();
        const baseOption = {
            'skip-install': this.options['skip-install'],
            plusbeta: this.options.plusbeta
        };
        this.env.options.nodePackageManager = this.options.packageManager || 'npm';
        // Config destination root before composition.
        _solution.composeWith(this, baseOption);
        _component.composeWith(this, baseOption);
        _webpart.composeWith(this, baseOption);
        _extension.composeWith(this, baseOption);
        _library.composeWith(this, baseOption);
        _adaptiveCardExtension.composeWith(this, baseOption);
        _fieldCustomizer.composeWith(this, baseOption);
        _commandSet.composeWith(this, baseOption);
        _searchQueryModifier.composeWith(this, baseOption);
        _applicationCustomizer.composeWith(this, baseOption);
        _formCustomizer.composeWith(this, baseOption);
        _genericAdaptiveCardExtension.composeWith(this, baseOption);
        _searchAdaptiveCardExtension.composeWith(this, baseOption);
        _dataVisualizationAdaptiveCardExtension.composeWith(this, baseOption);
    }
    prompting() {
        // Configure the solution root folder before other composition.
        if (this.context.creatingSolution) {
            // Create solution because not in a solution folder
            this.log(`Let's create a new Microsoft 365 solution.`);
        }
    }
    configuring() {
    /* no-op */ }
    writing() {
    /* no-op */ }
    install() {
    /* no-op */ }
    end() {
        const libraryName = _YeomanConfiguration.YeomanConfiguration.libraryName;
        const useHeft = _YeomanConfiguration.YeomanConfiguration.useHeft;
        this.log((0, _spsay.default)(libraryName, useHeft));
    }
    _provideRetirementNote() {
        this.log(_colors.default.bold(`See ${_colors.default.underline(_colors.default.blue('https://aka.ms/spfx-yeoman-info'))} for more information on how to use this generator.`));
    }
    _explainArguments() {
        // If the CLI argument is specified, the corresponding prompting in sub-generators will be skipped.
        // The following calls do similar jobs as prompting. Place them here instead of initializing step.
        if (this.options.solutionName) {
            const solutionName = _colors.default.cyan(this.options.solutionName);
            this.log(`A folder with solution name ${solutionName} will be created for you.`);
        }
        if (this.options.environment) {
            const environment = _colors.default.cyan(this.options.environment);
            this.log(`A component for the ${environment} environment will be created for you.`);
        }
        if (this.options.packageManager) {
            const packageManager = _colors.default.cyan(this.options.packageManager);
            this.log(`The ${packageManager} package manager will be used.`);
        }
        const componentType = this.options.componentType === 'webpart' ? 'web part' : this.options.componentType === 'extension' ? 'extension' : this.options.componentType === 'library' ? 'library' : this.options.componentType === 'adaptiveCardExtension' ? 'adaptiveCardExtension' : 'component';
        const componentTypeUpper = componentType.charAt(0).toUpperCase() + componentType.slice(1);
        if (this.options.componentName) {
            const webpartName = _colors.default.cyan(this.options.componentName);
            let frameworkWords = this.options.template;
            if (!frameworkWords) {
                frameworkWords = this.options.framework;
            }
            if (frameworkWords) {
                frameworkWords = ' with ' + _colors.default.cyan(frameworkWords) + ' framework';
            } else {
                frameworkWords = '';
            }
            this.log(`${componentType === 'extension' ? 'An' : 'A'} ${componentType} with the name ${webpartName}` + ` will be added to your solution${frameworkWords}.`);
        }
        if (this.options.componentDescription) {
            const description = _colors.default.cyan(this.options.componentDescription);
            this.log(`${componentTypeUpper} description is going to be ${description}.`);
        }
    }
    _setSDKsVersions() {
        const bundlesFile = _nodecorelibrary.JsonFile.load(`${__dirname}/../../common/bundles-versions.json`);
        this.config.set('sdksVersions', bundlesFile);
    }
    constructor(args, options){
        super(args, options);
        _define_property(this, "friendlyName", 'SharePoint Client-side Solution Generator');
        _define_property(this, "allowEmptyPackageJson", true);
        this.desc('Generate a SharePoint client-side solution with webparts.');
        _component.defineOptions(this);
        _solution.defineOptions(this);
    }
}
// Yeoman expects exports of this type, which overrides the TS exports above
// Ensure that anything marked as export above is also listed here
module.exports = AppGenerator;
module.exports.composeWith = composeWith;

//#sourceMappingUrl=./index.js.map