"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    CommandSetGenerator: function() {
        return CommandSetGenerator;
    },
    composeWith: function() {
        return composeWith;
    },
    defineOptions: function() {
        return defineOptions;
    }
});
const _path = /*#__PURE__*/ _interop_require_wildcard(require("path"));
const _utilities = /*#__PURE__*/ _interop_require_wildcard(require("../../common/utilities"));
const _BaseExtensionGenerator = /*#__PURE__*/ _interop_require_wildcard(require("../extension/BaseExtensionGenerator"));
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function composeWith(base, options) {
    _utilities.compose(_path.basename(__dirname), base, options);
}
function defineOptions(generator) {
    _BaseExtensionGenerator.defineOptions(generator, 'Command Set');
}
class CommandSetGenerator extends _BaseExtensionGenerator.BaseExtensionGenerator {
    initializing() {
    /* no-op */ }
    async prompting() {
        this.ensureCorrectFolder();
        if (this._shouldExecute()) {
            await super.prompting();
        }
    }
    configuring() {
        if (this._shouldExecute()) {
            super.configuring();
            this.ensureDependencyGroup('commandSet');
            this.serveJson.addConfiguration(this.context.componentNameCamelCase, {
                pageUrl: 'https://{tenantDomain}/SitePages/myPage.aspx',
                customActions: {
                    [this.context.componentId]: {
                        location: 'ClientSideExtension.ListViewCommandSet.CommandBar',
                        properties: {
                            sampleTextOne: 'One item is selected in the list',
                            sampleTextTwo: 'This command is always visible.'
                        }
                    }
                }
            });
        }
    }
    writing() {
        if (this._shouldExecute()) {
            super.writing();
        }
    }
    install() {
        if (this._shouldExecute()) {
            super.install();
        }
    }
    end() {
        super.end();
    }
    includeClientSideInstances() {
        return true;
    }
    _shouldExecute() {
        return this.config.get('environment') === 'spo' && this.config.get('componentType') === 'extension' && this.config.get('extensionType') === 'ListViewCommandSet';
    }
    constructor(args, options){
        super(args, options);
        _define_property(this, "friendlyName", 'Command Set');
        _define_property(this, "codeName", 'CommandSet');
        _define_property(this, "allowedTemplates", []);
        defineOptions(this);
    }
}
// Yeoman expects exports of this type, which overrides the TS exports above
// Ensure that anything marked as export above is also listed here
module.exports = CommandSetGenerator;
module.exports.defineOptions = defineOptions;
module.exports.composeWith = composeWith;

//#sourceMappingUrl=./index.js.map