"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    FormCustomizerGenerator: function() {
        return FormCustomizerGenerator;
    },
    composeWith: function() {
        return composeWith;
    },
    defineOptions: function() {
        return defineOptions;
    }
});
const _path = /*#__PURE__*/ _interop_require_wildcard(require("path"));
const _utilities = /*#__PURE__*/ _interop_require_wildcard(require("../../common/utilities"));
const _YeomanConfiguration = require("../../common/YeomanConfiguration");
const _BaseExtensionGenerator = /*#__PURE__*/ _interop_require_wildcard(require("../extension/BaseExtensionGenerator"));
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function composeWith(base, options) {
    _utilities.compose(_path.basename(__dirname), base, options);
}
function defineOptions(generator) {
    _BaseExtensionGenerator.defineOptions(generator, 'Form Customizer');
}
class FormCustomizerGenerator extends _BaseExtensionGenerator.BaseExtensionGenerator {
    initializing() {
    /* no-op */ }
    prompting() {
        this.ensureCorrectFolder();
        if (!this._shouldExecute()) {
            return Promise.resolve();
        }
        return super.prompting();
    }
    configuring() {
        if (this._shouldExecute()) {
            super.configuring();
            this.ensureDependencyGroup('formCustomizer');
            // New Form
            this.serveJson.addConfiguration(`${this.context.componentNameCamelCase}_NewForm`, {
                pageUrl: 'https://{tenantDomain}/_layouts/15/SPListForm.aspx',
                formCustomizer: {
                    componentId: this.context.componentId,
                    PageType: 8,
                    RootFolder: '/sites/mySite/Lists/MyList',
                    properties: {
                        sampleText: 'Value'
                    }
                }
            });
            // Edit Form
            this.serveJson.addConfiguration(`${this.context.componentNameCamelCase}_EditForm`, {
                pageUrl: 'https://{tenantDomain}/_layouts/15/SPListForm.aspx',
                formCustomizer: {
                    componentId: this.context.componentId,
                    PageType: 6,
                    RootFolder: '/sites/mySite/Lists/MyList',
                    ID: 1,
                    properties: {
                        sampleText: 'Value'
                    }
                }
            });
            // View Form
            this.serveJson.addConfiguration(`${this.context.componentNameCamelCase}_ViewForm`, {
                pageUrl: 'https://{tenantDomain}/_layouts/15/SPListForm.aspx',
                formCustomizer: {
                    componentId: this.context.componentId,
                    PageType: 4,
                    RootFolder: '/sites/mySite/Lists/MyList',
                    ID: 1,
                    properties: {
                        sampleText: 'Value'
                    }
                }
            });
        }
    }
    writing() {
        if (this._shouldExecute()) {
            super.writing(false);
            const dest = this._getOutputFolder(this.context.componentNameCamelCase);
            const template = this.context.template;
            this.copyTemplate(_path.join(this.sourceRoot(), template), dest);
            if (template !== 'minimal') {
                this.copyTemplate(_path.join(this.sourceRoot(), 'loc'), _path.join(dest, 'loc'));
            }
            this.copyTemplate(_path.join(this.sourceRoot(), 'base'), dest);
        }
    }
    install() {
        if (this._shouldExecute()) {
            super.install();
        }
    }
    end() {
        super.end();
    }
    addFeature() {
        if (this._shouldExecute() && !this.hasElementsXml()) {
            const solutionName = _YeomanConfiguration.YeomanConfiguration.libraryName;
            this.packageSolutionJson.addFeature(_utilities.generateGuid(), `${solutionName} Feature`, `The feature that activates elements of the ${solutionName} solution.`, false);
        }
    }
    includeClientSideInstances() {
        return false;
    }
    _shouldExecute() {
        return this.config.get('environment') === 'spo' && this.config.get('componentType') === 'extension' && this.config.get('extensionType') === 'FormCustomizer';
    }
    constructor(args, options){
        super(args, options);
        _define_property(this, "friendlyName", 'Form Customizer');
        _define_property(this, "codeName", 'FormCustomizer');
        _define_property(this, "allowedTemplates", [
            'react',
            'none'
        ]);
        defineOptions(this);
    }
}
// Yeoman expects exports of this type, which overrides the TS exports above
// Ensure that anything marked as export above is also listed here
module.exports = FormCustomizerGenerator;
module.exports.defineOptions = defineOptions;
module.exports.composeWith = composeWith;

//#sourceMappingUrl=./index.js.map