"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    GenericAdaptiveCardExtensionGenerator: function() {
        return GenericAdaptiveCardExtensionGenerator;
    },
    composeWith: function() {
        return composeWith;
    },
    defineOptions: function() {
        return defineOptions;
    }
});
const _path = /*#__PURE__*/ _interop_require_wildcard(require("path"));
const _utilities = /*#__PURE__*/ _interop_require_wildcard(require("../../common/utilities"));
const _BaseAdaptiveCardExtensionGenerator = require("../adaptiveCardExtension/BaseAdaptiveCardExtensionGenerator");
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function composeWith(base, options) {
    _utilities.compose(_path.basename(__dirname), base, options);
}
function defineOptions(generator) {
/* no-op */ }
class GenericAdaptiveCardExtensionGenerator extends _BaseAdaptiveCardExtensionGenerator.BaseACEGenerator {
    initializing() {
    /* no-op */ }
    async prompting() {
        this.ensureCorrectFolder();
        if (this._shouldExecute()) {
            await super.prompting();
        }
    }
    configuring() {
        if (this._shouldExecute()) {
            super.configuring();
        }
    }
    writing() {
        if (this._shouldExecute()) {
            super.writing(true);
            // copy view template
            this.copyTemplate(this._getTemplatePath(this.config.get('aceTemplateType')), this.destinationPath(`src/adaptiveCardExtensions/${this.context.componentNameCamelCase}/cardView`));
            // copy manifest.json path
            this.copyTemplate(this._getManifestTemplatePath(this.config.get('aceTemplateType')), this.destinationPath(`src/adaptiveCardExtensions/${this.context.componentNameCamelCase}`));
        }
    }
    install() {
        if (this._shouldExecute()) {
            super.install();
        }
    }
    end() {
        super.end();
    }
    _shouldExecute() {
        return this.config.get('environment') === 'spo' && this.config.get('componentType') === 'adaptiveCardExtension' && this.config.get('isDomainIsolated') === false && [
            'Basic',
            'Image',
            'PrimaryText',
            'Generic'
        ].indexOf(this.config.get('aceTemplateType')) !== -1;
    }
    _getTemplatePath(templateType) {
        switch(templateType){
            case 'Image':
                return this.templatePath('./imageCardView/');
            case 'PrimaryText':
                return this.templatePath('./primaryTextCardView/');
            case 'Basic':
                return this.templatePath('./basicCardView/');
            case 'Generic':
                return this.templatePath('./genericCardView/');
            default:
                throw new Error(`Invalid template type '${templateType}'`);
        }
    }
    _getManifestTemplatePath(templateType) {
        switch(templateType){
            case 'Image':
                return this.templatePath('./manifestTemplate/imageTemplate/');
            case 'Generic':
                return this.templatePath('./manifestTemplate/componentsTemplate/');
            default:
                return this.templatePath('./manifestTemplate/baseTemplate/');
        }
    }
    constructor(args, options){
        super(args, options);
        defineOptions(this);
    }
}
// Yeoman expects exports of this type, which overrides the TS exports above
// Ensure that anything marked as export above is also listed here
module.exports = GenericAdaptiveCardExtensionGenerator;
module.exports.defineOptions = defineOptions;
module.exports.composeWith = composeWith;

//#sourceMappingUrl=./index.js.map