"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    WebpartGenerator: function() {
        return WebpartGenerator;
    },
    composeWith: function() {
        return composeWith;
    },
    defineOptions: function() {
        return defineOptions;
    }
});
const _path = /*#__PURE__*/ _interop_require_wildcard(require("path"));
const _utilities = /*#__PURE__*/ _interop_require_wildcard(require("../../common/utilities"));
const _YeomanConfiguration = require("../../common/YeomanConfiguration");
const _BaseComponentGenerator = /*#__PURE__*/ _interop_require_wildcard(require("../component/BaseComponentGenerator"));
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interop_require_wildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {
        __proto__: null
    };
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
function composeWith(base, options) {
    _utilities.compose(_path.basename(__dirname), base, options);
}
function defineOptions(generator) {
    _BaseComponentGenerator.defineOptions(generator, 'Web part');
}
class WebpartGenerator extends _BaseComponentGenerator.BaseComponentGenerator {
    initializing() {
    /* no-op */ }
    async prompting() {
        this.ensureCorrectFolder();
        if (this._shouldExecute()) {
            await super.prompting();
        }
    }
    configuring() {
        if (this._shouldExecute()) {
            super.configuring();
            this.ensureDependencyGroup('webpart');
            this.serveJson.setUpForWebParts();
            const solutionName = _YeomanConfiguration.YeomanConfiguration.libraryName;
            this.packageSolutionJson.addFeature(_utilities.generateGuid(), `${solutionName} Feature`, `The feature that activates elements of the ${solutionName} solution.`, false);
        }
    }
    writing() {
        if (this._shouldExecute()) {
            super.writing(false);
            const dest = this._getOutputFolder(this.context.componentNameCamelCase);
            const template = this.context.template;
            this.copyTemplate(_path.join(this.sourceRoot(), template), dest);
            if (template !== 'minimal') {
                this.copyTemplate(_path.join(this.sourceRoot(), 'loc'), _path.join(dest, 'loc'));
                this.copyTemplate(_path.join(this.sourceRoot(), 'assets'), _path.join(dest, 'assets'));
            }
            this.copyTemplate(_path.join(this.sourceRoot(), 'base'), dest);
            this.fs.copy(this.templatePath('./images/outline.png'), this.destinationPath(`teams/${this.context.componentId}_outline.png`));
            this.fs.copy(this.templatePath('./images/color.png'), this.destinationPath(`teams/${this.context.componentId}_color.png`));
        }
    }
    install() {
        if (this._shouldExecute()) {
            super.install();
        }
    }
    end() {
        super.end();
    }
    _shouldExecute() {
        return this.config.get('environment') === 'spo' && this.config.get('componentType') === 'webpart';
    }
    constructor(args, options){
        super(args, options);
        _define_property(this, "friendlyName", 'Web part');
        _define_property(this, "codeName", 'WebPart');
        _define_property(this, "allowedTemplates", [
            'react',
            'minimal'
        ]);
        _define_property(this, "folderName", 'webparts');
        defineOptions(this);
    }
}
// Yeoman expects exports of this type, which overrides the TS exports above
// Ensure that anything marked as export above is also listed here
module.exports = WebpartGenerator;
module.exports.defineOptions = defineOptions;
module.exports.composeWith = composeWith;

//#sourceMappingUrl=./index.js.map